@import '../global/var';

$mobile-card-padding-bottom: 15px;
$mobile-card-row-height: 38px;
$mobile-card-border-width: 1px;
$content-wrapper-padding-top: 12px;
$controls-wrapper-padding-bottom: 26px;

.page {
    &.zebrunner-dashboards {
        padding-bottom: 70px;
    }

    & .content {
        &-wrapper {
            max-width: 1024px;
            margin: 0 auto;
            padding-top: $content-wrapper-padding-top;

            & .controls__wrapper {
                display: flex;
                padding-bottom: $controls-wrapper-padding-bottom;
            }

            & .input {
                max-width: 360px;

                &__container {
                    flex: 1 1 auto;
                }
            }

            & .button {
                flex: 0 0 174px;
                display: flex;
                align-items: center;
                padding: 10px 16px;

                &__icon {
                    line-height: 16px;
                }

                &__text {
                    padding-left: 16px;
                }
            }

            .users,
            .dashboards {
                &-table {
                    &__container {
                        max-height: calc(100vh - #{$content-wrapper-padding-top} - #{$controls-wrapper-padding-bottom} - 80px - 70px - 36px);
                        /*
                            80px - page container padding top
                            70px - page container padding bottom
                            36px - controls height
                        */
                        overflow-y: scroll;
                        box-shadow: 0 -2px 5px rgba(0,0,0,.06), 0 1px 10px rgba(0,0,0,.08), 0 2px 4px rgba(0,0,0,.14);

                        & .limit-select {
                            order: 2;
                            margin-left: auto;

                            & .label {
                                order: 1;
                                padding-right: 0;
                            }

                            & .md-table-select {
                                min-width: 45px;
                                order: 2;
                                font-size: 14px;
                                font-weight: normal;
                                color: rgba(0, 0, 0, 0.54);
                            }
                        }

                        & .buttons {
                            margin-left: 0;
                        }
                    }

                    &__header {
                        position: sticky;
                        top: 0;
                        z-index: 2;
                        background-color: $gray7f7;

                        &-button {
                            display: flex;
                            align-items: center;
                            padding: 10px 10px 10px 0;

                            & span {
                                text-transform: uppercase;
                            }

                            & .material-icons {
                                &._active-asc,
                                &._active-desc {
                                    display: none;
                                }
                            }

                            &._active-asc,
                            &._active-desc {
                                & span {
                                    color: $black;
                                }
                                & .material-icons {
                                    display: none;
                                }
                            }

                            &._active-asc {
                                & .material-icons._active-asc {
                                    display: block;
                                    fill: $black;
                                    color: $brand-light;
                                }
                            }

                            &._active-desc {
                                & .material-icons._active-desc {
                                    display: block;
                                    fill: $black;
                                    color: $brand-light;
                                }
                            }
                        }

                        .users,
                        .dashboards {
                            &-table {
                                &__row {
                                    display: flex;
                                    height: 48px;
                                    box-shadow: inset 0px -1px 0px $gray3e5;
                                    border-bottom: 1px solid rgba(0, 0, 0, 0.12);
                                }

                                &__col {
                                    display: flex;
                                    align-items: center;
                                    justify-content: flex-start;
                                    font-size: 12px;
                                    line-height: 16px;
                                    color: $gray57c;
                                    font-weight: 700;
                                    text-transform: uppercase;
                                    padding-left: 24px;

                                    &:first-child {
                                        flex: 0 0 64px;
                                        padding-left: 0;
                                    }

                                    &:last-child {
                                        flex: 0 0 84px;
                                    }

                                    &._name {
                                        flex: 1 1 28.5%;
                                        color: $gray57c;
                                    }

                                    &._cat {
                                        flex: 1 1 14.7%;
                                    }

                                    &._key {
                                        flex: 1 1 10.4%;
                                    }

                                    &._lead {
                                        flex: 1 1 19.2%;
                                    }

                                    &._created {
                                        flex: 1 1 15%;
                                    }

                                    &._members {
                                        flex: 1 1 12.2%;
                                    }

                                    &._username,
                                    &._role,
                                    &._added {
                                        flex: 1 1 33%;
                                    }
                                    &._edit {
                                        flex: 0 0 84px;
                                    }

                                    & .material-icons {
                                        font-size: 16px;
                                        height: 16px;
                                        min-height: 16px;
                                        width: 16px;
                                        min-width: 16px;
                                        margin: 0 0 0 12px;
                                    }
                                }
                            }
                        }
                        .dashboards {
                            &-table {
                                &__col {
                                    font-weight: 600;
                                    &:first-child {
                                        flex: 1 1 0;
                                        padding-left: 24px;
                                        justify-content: flex-start;
                                    }
                                    &._name {
                                        flex: 1 1 50%;
                                    }
                                    &._created {
                                        flex: 1 1 40%;
                                    }
                                }
                            }
                        }
                    }

                    &__row {
                        display: flex;
                        height: 48px;
                        border-bottom: 1px solid rgba(0, 0, 0, 0.12);

                        &._centered {
                            align-items: center;
                            justify-content: center;
                        }
                    }

                    &__col {
                        display: flex;
                        align-items: center;
                        justify-content: flex-start;
                        font-size: 14px;
                        line-height: 24px;
                        font-weight: 400;
                        padding-left: 24px;
                        overflow: hidden;

                        &:first-child {
                            flex: 0 0 64px;
                            padding-left: 0;
                            display: flex;
                            align-items: center;
                            justify-content: center;
                        }

                        &:last-child {
                            flex: 0 0 84px;
                        }

                        &._name {
                            flex: 1 1 28.5%;
                            color: $brand-primary;
                        }

                        &._cat {
                            flex: 1 1 14.7%;
                        }

                        &._key {
                            flex: 1 1 10.4%;
                        }

                        &._lead {
                            flex: 1 1 19.2%;

                            & .profile-photo {
                                margin-right: 8px;
                                flex-shrink: 0;
                            }
                        }

                        &._created {
                            flex: 1 1 15%;
                        }

                        &._members {
                            flex: 1 1 12.2%;
                        }

                        &._username,
                        &._role,
                        &._added {
                            flex: 1 1 33%;
                        }

                        &._edit {
                            flex: 1 1 84px;
                        }
                        &._role {
                            text-transform: capitalize;
                        }
                        &._edit, &._delete {
                            .material-icons {
                                color: $gray57c;
                                &:hover {
                                    color: $black;
                                }
                            }
                        }
                    }

                    &__button {
                        border: 0;
                        background-color: $white;
                    }

                    &__content {
                        overflow: hidden;
                        text-overflow: ellipsis;
                        white-space: nowrap;

                        &._link {
                            color: $brand-light;
                            text-decoration: none;
                            font-weight: 500;
                            transition: color .25s linear;

                            &:hover {
                                color: $brand-light-hover;
                            }
                        }

                        &._secondary {
                            color: $gray8be;
                        }
                    }

                    &__role {
                        & .md-select-value {
                            padding-left: 0;
                        }

                        &[disabled] {
                            .md-select-icon {
                                display: none;
                            }
                        }
                        & .md-select-value {
                            border: none !important;  // to remove border when active
                            background-color: transparent !important;
                        }

                        &-container {
                            max-width: 200px;
                        }

                        &-name {
                            text-transform: capitalize;
                            color: $black;
                        }

                        &-description {
                            display: none;
                        }
                    }

                    &__loader {
                        margin: 0 auto;
                        align-self: center;
                    }

                    &__message {
                        line-height: 48px;
                    }
                }

                &-photo {
                    &__icon-wrapper {
                        & .icon {
                            font-size: 32px;
                            height: 32px;
                            width: 32px;
                            min-height: 32px;
                            min-width: 32px;
                        }
                    }
                }
            }
            .dashboards {
                &-table {
                    &__content {
                        &._link {
                            cursor: pointer;
                        }
                    }
                    &__col {
                        &:first-child {
                            flex: 1 1 0;
                            padding-left: 24px;
                            justify-content: flex-start;
                        }
                        &._name {
                            flex: 1 1 50%;
                        }
                        &._created {
                            flex: 1 1 40%;
                        }
                    }
                }
            }
        }
    }
    &.zebrunner-dashboards {
        & .content {
            &-wrapper {
                & .button {
                    flex: 0 0 190px;
                }
            }
        }
    }
}

.users-table {
    &__role {
        &-list-item {
            max-width: 286px;
            height: auto;
            padding: 8px 16px;
        }

        &-name {
            font-weight: 500;
            line-height: 24px;
            text-transform: capitalize;
        }

        &-description {
            font-size: 11px;
            line-height: 16px;
            white-space: normal;
        }
    }
}

@media screen and (max-width: $breakpoint-tablet-s) { //998px
    .page {
        & .content {
            &-wrapper {
                .users,
                .dashboards {
                    &-table {
                        &__header {
                            .users,
                            .dashboards {
                                &-table {
                                    &__col {
                                        padding-left: 10px;

                                        &:first-child {
                                            flex: 0 0 50px;
                                        }

                                        &:last-child {
                                            flex: 0 0 54px;
                                        }

                                        &._username,
                                        &._role {
                                            flex: 1 1 38%;
                                        }

                                        &._added {
                                            flex: 1 1 24%;
                                        }
                                    }
                                }
                            }
                            .dashboards {
                                &-table {
                                    &__col {
                                        &:first-child {
                                            flex: 0 0 50%;
                                        }
                                        &._name {
                                            width: 50%;
                                        }
                                        &._edit {
                                            flex: 1 1 54px;
                                        }
                                    }
                                }
                            }
                        }

                        &__col {
                            padding-left: 10px;

                            &:first-child {
                                flex: 0 0 50px;
                            }

                            &:last-child {
                                flex: 0 0 54px;
                            }

                            &._username,
                            &._role {
                                flex: 1 1 38%;
                            }

                            &._added {
                                flex: 1 1 24%;
                            }
                        }
                    }
                }
                .dashboards {
                    &-table {
                        &__col {
                            &:first-child {
                                flex: 0 0 50%;
                            }
                            &._name {
                                width: 50%;
                            }
                            &._edit {
                                flex: 1 1 54px;
                            }
                        }
                    }
                }
            }
        }
    }
}

@media screen and (max-width: $screen-sm-min) { // 768px
    .page {
        .content-wrapper {
            & .input {
                padding-right: 24px;
            }
        }
    }
}

@media screen and (max-width: $breakpoint-mobile) { //600px
    .page {
        .content-wrapper {
            & .controls__wrapper {
                display: flex;
                flex-direction: column;
                align-items: flex-end;
                padding-bottom: 24px;
            }

            .button {
                order: 1;
                max-width: 140px;
                padding: 10px;
                margin-bottom: 16px;

                &__icon {
                    font-size: 18px;
                    width: 12px;
                    height: 12px;
                }

                &__text {
                    padding-left: 10px;
                    font-size: 12px;
                }
            }

            & .input {
                width: 100%;
                max-width: none;
                padding-right: 0;

                &__container {
                    width: 100%;
                    order: 2;
                }
            }

            .users-table {
                display: flex;
                flex-wrap: wrap;
                position: relative;

                &__header {
                    display: none;
                }

                &__row {
                    height: auto;
                    display: grid;
                    position: relative;
                    padding-bottom: 0;
                    border: 0;
                    border-top: $mobile-card-border-width solid rgba(0, 0, 0, 0.12);
                    z-index: 2;

                    &:first-child {
                        border-top: $mobile-card-border-width solid rgba(0, 0, 0, 0.12);
                    }

                    &:nth-child(2n+1) {
                        border-right: $mobile-card-border-width solid rgba(0, 0, 0, 0.12);
                    }

                    &:hover {
                        background-color: inherit;
                    }
                }

                &__col {
                    display: flex;
                    align-items: center;
                    height: 38px;
                    padding-right: 0;
                    overflow: hidden;
                    text-overflow: ellipsis;
                    max-width: 100%;
                    position: relative;
                    z-index: 2;

                    &._username {
                        position: absolute;
                        top: 0;
                        left: 80px;
                        height: 48px;
                        max-width: calc(100% - 96px - 48px); //48 - edit button width; 96 - project image width
                    }

                    &[data-title] {
                        display: flex;
                        align-items: center;

                        &:before {
                            padding-left: 24px;
                            margin-right: 24px;
                            content: attr(data-title);
                            color: $gray8be;
                            opacity: 1;
                            font-size: 10px;
                            font-weight: 500;
                            line-height: inherit;
                            flex: 0 0 30%;
                            min-width: 120px;
                            max-width: 120px;
                            text-transform: uppercase;
                        }
                    }

                    &._centered {
                        justify-content: start;
                    }

                    &:first-child,
                    &:last-child {
                        &._centered {
                            position: relative;
                            padding: 0;
                            flex: 1 1 auto;
                            justify-content: center;

                            &:after {
                                display: none;
                            }
                        }
                    }

                    &:first-child {
                        height: 48px;
                        flex: 0 0 88px;
                        padding: 0 24px;
                        justify-content: flex-start;
                        background-color: $gray7f7;

                        &:before {
                            display: none;
                        }

                        &:after {
                            content: attr(data-title);
                            padding-left: 24px;
                            text-overflow: ellipsis;
                            overflow: hidden;
                            flex: 0 0 70%;
                        }
                    }

                    &:last-child {
                        position: absolute;
                        top: 0;
                        right: 0;
                        height: 48px;
                        padding: 0 24px 0 0;
                        background-color: $gray7f7;
                    }
                }

                &__button {
                    background-color: transparent;
                }

                &__role {
                    max-width: 130px;
                }
            }

            .users-table,
            .dashboards-table {
                &__container {
                    max-height: calc(100vh - 12px - 100px - 112px);

                    & .limit-select {
                        display: none;
                    }
                }

                &__row {
                    flex: 0 0 100%;
                    width: 100%;
                }

                &:before,
                &:after {
                    display: none;
                }
            }
            .dashboards {
                &-table {
                    &__header {
                        .dashboards {
                            &-table {
                                &__col {
                                    &._edit,
                                    &._delete {
                                        display: none;
                                    }
                                    &._created {
                                        flex: 1 1 50%;
                                    }
                                    &:first-child {
                                        flex: 1 1 50%;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            .dashboards {
                &-table {
                    &__col {
                        &._edit,
                        &._delete {
                            display: none;
                        }
                        &._created {
                            flex: 0 0 50%;
                        }
                        &:first-child {
                            flex: 0 0 50%;
                        }
                    }
                }
            }
        }
    }
    &.zebrunner-dashboards {
        & .content {
            &-wrapper {
                & .button {
                    display: none;
                }
            }
        }
    }
}
